unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, Buttons, Spin;

type
  TForm1 = class(TForm)
    IdFTP1: TIdFTP;
    GroupBox1: TGroupBox;
    EditServeur: TEdit;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    LabelConnecte: TLabel;
    BitBtnConnexion: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditUserName: TEdit;
    EditPassWord: TEdit;
    SpinEditPort: TSpinEdit;
    LabelErreur: TLabel;
    ButtonDeConnexion: TButton;
    GroupBox3: TGroupBox;
    BitBtnEnvoyer: TBitBtn;
    EditFichierLocal: TEdit;
    BitBtnParcourir: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label5: TLabel;
    EditNomFichierSurServeur: TEdit;
    Label6: TLabel;
    ButtonRecevoir: TButton;
    ButtonEffacer: TButton;
    Label7: TLabel;
    GroupBox4: TGroupBox;
    EditNomDossier: TEdit;
    BitBtnEffacer: TBitBtn;
    BitBtnCreer: TBitBtn;
    BitBtnrenommerDossier: TBitBtn;
    Label8: TLabel;
    EditNouveauNomDossier: TEdit;
    ButtonrenommerFicher: TButton;
    EditNouveauNomFichier: TEdit;
    GroupBox5: TGroupBox;
    Memo1: TMemo;
    BitBtnVoirContenuUnDossier: TBitBtn;
    EditNomDuDossierAExplorer: TEdit;
    SpinEditTimeOut: TSpinEdit;
    Label10: TLabel;
    GroupBox6: TGroupBox;
    Label9: TLabel;
    BitBtnCreerDesSousSousDossiers: TBitBtn;
    EditNomDesDossiersACreer: TEdit;
    LabelAvancement: TLabel;

    procedure Connection;
    procedure IdFTP1Connected(Sender: TObject);
    procedure IdFTP1Disconnected(Sender: TObject);
    procedure BitBtnConnexionClick(Sender: TObject);
    procedure ButtonDeConnexionClick(Sender: TObject);
    procedure BitBtnEnvoyerClick(Sender: TObject);
    procedure BitBtnParcourirClick(Sender: TObject);
    procedure IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure ButtonEffacerClick(Sender: TObject);
    procedure ButtonRecevoirClick(Sender: TObject);
    procedure BitBtnCreerClick(Sender: TObject);
    procedure BitBtnEffacerClick(Sender: TObject);
    procedure BitBtnrenommerDossierClick(Sender: TObject);
    procedure ButtonrenommerFicherClick(Sender: TObject);
    procedure BitBtnVoirContenuUnDossierClick(Sender: TObject);
    procedure BitBtnCreerDesSousSousDossiersClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

    function ForceFTPDirectories(Var IdFTP1:TidFTP; Folder: String): Boolean;
var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.IdFTP1Connected(Sender: TObject);
begin
  LabelConnecte.Caption:='Connect';
end;

procedure TForm1.IdFTP1Disconnected(Sender: TObject);
begin
  LabelConnecte.Caption:='Dconnect';
end;

procedure TForm1.BitBtnConnexionClick(Sender: TObject);
begin
   Connection;
end;

procedure TForm1.ButtonDeConnexionClick(Sender: TObject);
begin
  IdFTP1.Disconnect;
end;


function GaucheDuDernier(substr: string; s: string): string;
{=================================================================================}
{ fonction qui renvoie la sous chaine de caractre situe  gauche du dernier '/" }
{=================================================================================}
var
 i, PosDernier:integer;
begin
 for i:=1 to Length(s) do if  (s[i]='/') then PosDernier:=i;
 result:=Copy(s, 1, PosDernier);
end;


procedure TForm1.BitBtnEnvoyerClick(Sender: TObject);
Var Dossiers: String;
begin
     LabelErreur.Caption:='';
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then
     begin
       Dossiers := GaucheDuDernier( '/',EditNomFichierSurServeur.Text);// on ne retient que la partie Chemin
       ForceFTPDirectories(IdFTP1, Dossiers);// cration des sous dossiers s'ils n'existent pas
       IdFTP1.Put(EditFichierLocal.Text, EditNomFichierSurServeur.Text, false);
     end;
end;

procedure TForm1.ButtonRecevoirClick(Sender: TObject);
begin
     LabelErreur.Caption:='';
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then
     begin
       IdFTP1.Get(EditNomFichierSurServeur.Text, EditFichierLocal.Text, True, false);
     end;
end;

procedure TForm1.BitBtnParcourirClick(Sender: TObject);
begin
 if OpenDialog1.Execute then EditFichierLocal.Text:=OpenDialog1.FileName;
end;

procedure TForm1.Connection;
begin
  IdFTP1.Host := EditServeur.Text;
  IdFTP1.Port := SpinEditPort.Value;
  IdFTP1.Username := EditUserName.Text;
  IdFTP1.Password := EditPassWord.Text;
  IdFTP1.ReadTimeout:=SpinEditTimeOut.Value;
  try
    IdFTP1.Connect();
  except
    On E:Exception do LabelErreur.Caption:=(E.message);
  end;
end;

procedure TForm1.IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  if AWorkMode=wmWrite then LabelAvancement.Caption:='Ecriture du fichier en cours';
  if AWorkMode=wmRead then LabelAvancement.Caption:='Lecture du fichier en cours';
  LabelAvancement.Update;
end;

procedure TForm1.IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
    LabelAvancement.Caption:='Opration termine';
end;

procedure TForm1.ButtonEffacerClick(Sender: TObject);
begin
   IdFTP1.Delete(EditNomFichierSurServeur.Text);
end;



procedure TForm1.BitBtnCreerClick(Sender: TObject);
begin
     LabelErreur.Caption:='';
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then IdFTP1.MakeDir(EditNomDossier.Text);
end;

procedure TForm1.BitBtnEffacerClick(Sender: TObject);
begin
     LabelErreur.Caption:='';
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then IdFTP1.RemoveDir(EditNomDossier.Text);
end;

procedure TForm1.BitBtnrenommerDossierClick(Sender: TObject);
begin
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then IdFTP1.Rename(EditNomDossier.Text,EditNouveauNomDossier.Text);
end;

procedure TForm1.ButtonrenommerFicherClick(Sender: TObject);
begin
     if not (IdFTP1.Connected) then Connection;
     if IdFTP1.Connected then IdFTP1.Rename(EditNomFichierSurServeur.Text,EditNouveauNomFichier.Text);
end;

procedure TForm1.BitBtnVoirContenuUnDossierClick(Sender: TObject);
Var DossierCourant:String;
begin
   if not (IdFTP1.Connected) then Connection;
   DossierCourant:=IdFTP1.RetrieveCurrentDir;
   if EditNomDuDossierAExplorer.Text<>'' then IdFTP1.ChangeDir(EditNomDuDossierAExplorer.Text);
   IdFTP1.List(Memo1.Lines);
   IdFTP1.ChangeDir(DossierCourant);
end;


// Cration sur le serveur des sous-dossiers s'ils n'existent pas
// exemple : /toto/sousDossier1/SousDossier2
function ForceFTPDirectories(Var IdFTP1:TidFTP; Folder: String): Boolean;
var
  i: Integer;
  Previous, Tmp: String;
begin
  Result := False;
  if (Folder = '') then Exit; 
  try
    Previous := IdFTP1.RetrieveCurrentDir;
    try
      if (Folder[1] = '/') then
      begin
        Folder := Copy(Folder, 2, Length(Folder)-1);
        IdFTP1.ChangeDir('/');
      end;
      repeat
        i := Pos('/', Folder);
        if (i = 0) then
        begin
          Tmp := Folder;
          Folder := '';
        end
        else
        begin
          Tmp := Copy(Folder, 1, i-1);
          Folder := Copy(Folder, i+1, Length(Folder)-i);
        end;
        try
          IdFTP1.MakeDir(Tmp);
        except
        end;
        IdFTP1.ChangeDir(Tmp);
        until (i = 0);
         Result := True;
        finally
          IdFTP1.ChangeDir(Previous);
       end;
     except
  end;
end;



procedure TForm1.BitBtnCreerDesSousSousDossiersClick(Sender: TObject);
begin
  if not (IdFTP1.Connected) then Connection;
  ForceFTPDirectories(IdFTP1, EditNomDesDossiersACreer.Text);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IdFTP1.Disconnect;
end;

end.
